USE UdfDemo2;
go

SET STATISTICS IO ON;
go

SELECT     BigTableID,
           COALESCE (c.CountryName, s.StateName, a.AreaName,
                     r.RegionName, o.ContinentName) AS LocationName
FROM       dbo.BigTable   AS  t
LEFT  JOIN dbo.Countries  AS  c
      ON   c.CountryID     =  t.LocationID
      AND  t.LocationType  = 'C'
LEFT  JOIN dbo.States     AS  s
      ON   s.StateID       =  t.LocationID
      AND  t.LocationType  = 'S'
LEFT  JOIN dbo.Areas      AS  a
      ON   a.AreaID        =  t.LocationID
      AND  t.LocationType  = 'A'
LEFT  JOIN dbo.Regions    AS  r
      ON   r.RegionID      =  t.LocationID
      AND  t.LocationType  = 'R'
LEFT  JOIN dbo.Continents AS  o
      ON   o.ContinentID   =  t.LocationID
      AND  t.LocationType  = 'O';
go


SELECT     SalesID,
           COALESCE (c.CountryName, s.StateName, a.AreaName,
                     r.RegionName, o.ContinentName) AS LocationName
FROM       dbo.Sales      AS  t
LEFT  JOIN dbo.Countries  AS  c
      ON   c.CountryID     =  t.LocationID
      AND  t.LocationType  = 'C'
LEFT  JOIN dbo.States     AS  s
      ON   s.StateID       =  t.LocationID
      AND  t.LocationType  = 'S'
LEFT  JOIN dbo.Areas      AS  a
      ON   a.AreaID        =  t.LocationID
      AND  t.LocationType  = 'A'
LEFT  JOIN dbo.Regions    AS  r
      ON   r.RegionID      =  t.LocationID
      AND  t.LocationType  = 'R'
LEFT  JOIN dbo.Continents AS  o
      ON   o.ContinentID   =  t.LocationID
      AND  t.LocationType  = 'O';
go
